<?php
/********************************************************************
 * NotFTP v1.2.2 by Ryan Grove (ryan@wonko.com)
 * Copyright (c) 2002 Ryan Grove. All rights reserved.
 *
 * This script is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA  02111-1307  USA
 ********************************************************************/

include_once("functions.php");

set_time_limit(TIMEOUT);

if (isset($_POST["address"]))
{
    $address = trim($_POST["address"]);
    $user    = trim($_POST["user"]);
    $pass    = $_POST["pass"];
}
else
{
    $address = $_COOKIE["address"];
    $user    = $_COOKIE["user"];
    $pass    = $_COOKIE["pass"];
}

$error = false;

if ($address == "")
{
    $error = true;
    $errmsg = "You must enter the address of an FTP server to connect to, Einstein.";
}

if ($user == "")
    $user = "anonymous";

if ($pass == "")
    $pass = "anon@anon.com";

if (PASSTHRUDOWNLOAD === true && isset($_GET["f"]))
    $downloading = true;
else
    $downloading = false;

// Try to connect
if ($error === false && $downloading === false)
{
    $conn = ftp_connect($address, 21);

    if ($conn === false)
    {
        $error = true;
        $errmsg = "Could not connect to '$address'. Sorry.";
    }

    // Try to login
    if ($error === false)
    {
        $login = @ftp_login($conn, $user, $pass);

        if ($login === false)
        {
            $error = true;
            $errmsg = "Connected, but could not log in as '$user'. Sorry.";
        }

        // Set login cookies
        if ($error === false)
        {
            setcookie("address", $address, 0);
            setcookie("user", $user, 0);
            setcookie("pass", $pass, 0);

            if (TRANSFERLIMIT > 0 && !isset($_COOKIE["transfers"]))
                setcookie("transfers", 0, time() + 86400);

            if (TRANSFERQUOTA > 0 && !isset($_COOKIE["quota"]))
                setcookie("quota", 0, time() + 86400);
        }
    }
}

if ($error)
{
    include_once("lib/header.php");
    echo "<p><font color=red><b>Error:</b></font> $errmsg\n";
}
else
{
    if ($downloading === false)
    {
        // If PASVMODE is true, try to activate passive mode
        if (PASVMODE === true)
            @ftp_pasv($conn, true);
        else
            @ftp_pasv($conn, false);

        $rawlist = array();
        $nlist   = array();

        // Change directory
        if (isset($_GET["d"]))
        {
            if (!@ftp_chdir($conn, stripslashes($_GET["d"])))
                echo "<font color=red><b>Error:</b></font> Could not change directory to <b>".str_replace("//", "/", $_GET["d"])."</b>";
        }
    }

    // Handle commands
    if (isset($_GET["op"]))
        $op = $_GET["op"];
    elseif (isset($_POST["op"]))
        $op = $_POST["op"];

    if (isset($op))
    {
        switch($op)
        {
            case "cd":
                if (!@ftp_chdir($conn, stripslashes($_POST["text"])))
                    echo "<font color=red><b>Error:</b></font> Could not change directory to <b>".str_replace("//", "/", $_POST["text"])."</b>";
            break;


/*
 *This doesn't work yet.
 *
            case "custom":
                $pwd = $_COOKIE["pwd"];

                if (isset($_POST["text"]))
                {
                    // Close our current connection temporarily
                    ftp_quit($conn);

                    // Open a custom command socket
                    $cmdsock = fsockopen($address, 21);
                    fputs($cmdsock, "USER $user\r\n");
                    fputs($cmdsock, "PASS $pass\r\n");

                    // Execute the custom command
                    fputs($cmdsock, $_POST["text"]."\r\n");
                    $cmdresult = fread($cmdsock, 4096);

                    // Close the connection
                    fputs($cmdsock, "QUIT\r\n");
                    fclose($cmdsock);

                    // Reopen main connection
                    $conn = @ftp_connect($address, 21);
                    @ftp_login($conn, $user, $pass);
                }
                else
                {
                    echo "<font color=red><b>Error:</b></font> You need to enter a command to send or nothing will happen, bozo.\n";
                }
            break;
*/
            case "del":
                $pwd = $_COOKIE["pwd"];

                if (isset($_GET["dir"]))
                {
                    if (!@ftp_rmdir($conn, $_GET["dir"]))
                        echo "<font color=red><b>Error:</b></font> Could not remove the directory <b>".str_replace("//", "/", $_GET["dir"])."</b>. Are you sure it's empty and you have permission?";
                }
                elseif (isset($_GET["file"]))
                {
                    if (!@ftp_delete($conn, $pwd."/".$_GET["file"]))
                        echo "<font color=red><b>Error:</b></font> Could not delete <b>".str_replace("//", "/", $_GET["file"])."</b>. You may not have permission.";
                }
                ftp_chdir($conn, $pwd);
            break;

            case "mkdir":
                $pwd    = $_COOKIE["pwd"];
                $newdir = $pwd."/".$_POST["text"];
                @ftp_mkdir($conn, $newdir);
                ftp_chdir($conn, $pwd);
            break;

            case "logoff":
                // Delete all files downloaded during this session
                $downloaded = unserialize(base64_decode($_COOKIE["files"]));

                if (is_array($downloaded) && count($downloaded) > 0)
                {
                    foreach($downloaded as $file)
                        @unlink(FILEPATH."/$file");
                }

                // Unset all cookies
                setcookie("address", "", time() - 3600);
                setcookie("user", "", time() - 3600);
                setcookie("pass", "", time() - 3600);
                setcookie("pwd", "", time() - 3600);

                // Redirect to front page
                header("Location: ./");
            break;
        }
    }

    // Upload file
    if(isset($_POST["action"]))
    {
        $pwd      = $_COOKIE["pwd"];
        $filename = $_FILES["uploadfile"]["tmp_name"];
        $size     = $_FILES["uploadfile"]["size"];

        if ((TRANSFERLIMIT > 0) && ($_COOKIE["transfers"] > TRANSFERLIMIT))
        {
            echo "<font color=red><b>Error:</b></font> You have exceeded the transfer limit of ".TRANSFERLIMIT." file(s) per day. Come back tomorrow.";
        }
        else
        {
            if ((SIZELIMIT > 0 && $size > SIZELIMIT))
            {
                echo "<font color=red><b>Error:</b></font> This file is larger than the ".SIZELIMIT." byte transfer limit. Sorry.";
            }
            elseif ((TRANSFERQUOTA > 0) && (($_COOKIE["quota"] + $size) > TRANSFERQUOTA))
            {
                echo "<font color=red><b>Error:</b></font> Uploading this file would cause you to exceed the transfer quota of ".TRANSFERQUOTA." bytes per day. Come back tomorrow.";
            }
            else
            {
                if (!ftp_put($conn, $pwd."/".$_FILES["uploadfile"]["name"], $filename, FTP_BINARY))
                    echo "<font color=red><b>Error:</b></font> Could not upload the file. Are you sure you have upload permission?";
                elseif (TRANSFERLIMIT > 0)
                    setcookie("transfers", $_COOKIE["transfers"] + 1, time() + 86400);
            }
        }

        ftp_chdir($conn, $pwd);
    }

    // Download file
    if (isset($_GET["f"]))
    {
        if ((TRANSFERLIMIT > 0) && ($_COOKIE["transfers"] > TRANSFERLIMIT))
        {
            echo "<font color=red><b>Error:</b></font> You have exceeded the transfer limit of ".TRANSFERLIMIT." file(s) per day. Come back tomorrow.";
        }
        else
        {
            // Try to get file size
            if (PASSTHRUDOWNLOAD === true)
                $size = base64_decode(urldecode($_GET["s"]));
            else
                $size = @ftp_size($conn, $_GET["d"]."/".$_GET["f"]);

            if ((SIZELIMIT > 0 && $size > SIZELIMIT))
            {
                echo "<font color=red><b>Error:</b></font> This file is larger than the ".SIZELIMIT." byte transfer limit. Sorry.";
            }
            elseif ((TRANSFERQUOTA > 0) && (($_COOKIE["quota"] + $size) > TRANSFERQUOTA))
            {
                echo "<font color=red><b>Error:</b></font> Downloading this file would cause you to exceed the transfer quota of ".TRANSFERQUOTA." bytes per day. Come back tomorrow.";
            }
            elseif ($size != -1)
            {
                // Add this file to our "downloaded" list
                $downloaded = unserialize(base64_decode($_COOKIE["files"]));

                if (is_array($downloaded))
                    array_push($downloaded, $_GET["f"]);
                else
                    $downloaded = array($_GET["f"]);

                $downloaded = array_unique($downloaded);
                setcookie("transfers", $_COOKIE["transfers"] + 1, time() + 86400);
                setcookie("quota", $_COOKIE["quota"] + $size, time() + 86400);

                // Download the file
                if (PASSTHRUDOWNLOAD === true)
                {
                    if (strtolower($user) == "anonymous")
                        $fp = @fopen("ftp://$address".$_GET["d"]."/".$_GET["f"], "rb");
                    else
                        $fp = @fopen("ftp://$user:$pass@$address".$_GET["d"]."/".$_GET["f"], "rb");

                    if (!$fp)
                    {
                        include_once("lib/header.php");
                        echo "<p><b><font color=red>Error:</font></b> Could not connect to the server for passthru downloading. The server probably does not support passive mode. Sorry.";
                        include_once("lib/footer.php");
                        exit;
                    }
                }
                else
                {
                    $fp = fopen(FILEPATH."/".$_GET["f"], "w+b");
                    ftp_fget($conn, $fp, $_GET["d"]."/".$_GET["f"], FTP_BINARY);
                }

                // Send headers
                header("Cache-Control: no-cache, must-revalidate");
                header("Pragma: no-cache");
                header("Content-Type: ".getMIMEType($_GET["f"]));
                header("Content-Disposition: inline; filename=\"".$_GET["f"]."\"");
                header("Content-Length: $size");
                header("Expires: 0");

                // Send the file
                @rewind($fp);
                @fpassthru($fp) or @fclose($fp);

                // All done! Clean up.
                @fclose($fp);

                if (!PASSTHRUDOWNLOAD)
                {
                    @unlink(FILEPATH."/".$_GET["f"]);
                    @ftp_quit($conn);
                }
                exit;
            }
            else
            {
                echo "<font color=red><b>Error:</b></font> Could not determine this file's size. For security reasons, I can't let you download the file without knowing how large it is. Sorry.";
            }
        }
    }

    if ($downloading === true)
        exit;

    $pwd     = ftp_pwd($conn);
    $systype = ftp_systype($conn);
    $rawlist = ftp_rawlist($conn, "");
    $nlist   = rawlist2nlist($rawlist);

    @setcookie("pwd", $pwd, 0);

include_once("lib/header.php");
?>
<div class=path><?=$address.$pwd?></div>
<?
// If we've got a result from a custom command, let's display it
if (isset($cmdresult))
{
    ?>
    <div class=cmdresult>
        <b>Custom Command Result:</b>

        <p>
        <pre>
        <?=stripslashes(htmlspecialchars($cmdresult))?>
        </pre>
    </div>
    <?php
}
?>
<div class=dirlist>
<?
if ($debug)
{
    $downloaded = unserialize(base64_decode($_COOKIE["files"]));

    echo "<pre>";
    echo unserialize(base64_decode($_COOKIE["files"]));
    print_r($downloaded);
    echo "</pre>";

    echo "Systype: $systype";
    echo "<pre>".implode("\n", $nlist)."</pre>";
    echo "<pre>".implode("\n", $rawlist)."</pre>";
}

echo "<table cellspacing=1 width=\"100%\">\n";
echo "<tr><td class=tiny align=center>del</td><td class=tiny>name</td><td class=tiny>size (bytes)</td><td class=tiny>date</td><td class=tiny>permissions</td></tr>\n";
echo "<tr bgcolor=\"#f1f1f1\"><td>&nbsp;</td><td><b><a href=\"ftp.php?d=".urlencode($pwd."/..")."\">..</a></b></td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>\n";

// Print directory list
foreach($rawlist as $item)
{
    if ((isdir($item)) & (getName($item) != ".") & (getName($item) != ".."))
    {
        if ($pwd == "" | $pwd == "/")
            echo "<tr bgcolor=\"#f1f1f1\"><td width=20 align=center><a href=\"ftp.php?op=del&amp;dir=".urlencode("/".getName($item))."\">x</a></td><td width=\"45%\" nowrap><b><a href=\"ftp.php?d=".urlencode("/".getName($item))."\">".getName($item)."</a></b></td><td></td><td align=right nowrap><code>".getFileDate($item)."</code></td><td align=right nowrap><code>".getPermissions($item)."</code></td></tr>\n";
        else
            echo "<tr bgcolor=\"#f1f1f1\"><td width=20 align=center><a href=\"ftp.php?op=del&amp;dir=".urlencode($pwd."/".getName($item))."\">x</a></td><td width=\"45%\" nowrap><b><a href=\"ftp.php?d=".urlencode($pwd."/".getName($item))."\">".getName($item)."</a></b></td><td></td><td align=right nowrap><code>".getFileDate($item)."</code></td><td align=right nowrap><code>".getPermissions($item)."</code></td></tr>\n";
    }
}

// Print file list
foreach($rawlist as $item)
{
    if (isfile($item))
        echo "<tr bgcolor=\"#f9f9f9\"><td width=20 align=center><a href=\"ftp.php?op=del&amp;file=".urlencode(getName($item))."\">x</a></td><td width=\"45%\" nowrap><a href=\"ftp.php?d=".urlencode($pwd)."&amp;f=".urlencode(getName($item))."&amp;s=".urlencode(base64_encode(getSize($item)))."\">".getName($item)."</a></td><td align=right><code>".getSize($item)."</code></td><td nowrap align=right><code>".getFileDate($item)."</code></td><td align=right nowrap><code>".getPermissions($item)."</code></td></tr>\n";
}

echo "</table>\n";
?>
</div>
<form action="ftp.php" method=POST>
<div class=toolbar>
    <select name=op>
        <option value="cd">Change Directory
        <option value="mkdir">Make Directory
        <option value="logoff">Logoff
    </select>
    <input type=text name=text maxlength=255 size=20>
    <input type=submit value=Submit>
</div>
</form>

<form enctype="multipart/form-data" action="ftp.php" method=POST>
<div class=toolbar>
    <input type=hidden name="MAX_FILE_SIZE" value=<?=SIZELIMIT?>>
    <input type=hidden name=action value=upload>
    <input name=uploadfile type=file>
    <input type=submit value="Upload File">
</div>
</form>

<?php
    ftp_quit($conn);
}
include_once("lib/footer.php");
?>
